PROGRAM TUNE; { Turbo Pascal 6.0 }

USES  CRT,
      DOS,
      Fischer;


CONST Max_Randomtune = 30;
      Max_name = 10;

TYPE  t_Melodie = ARRAY[1..Max_Randomtune] OF BYTE;

      Players=RECORD
                   name:STRING[Max_Name];
                   Stage:BYTE;
              END;


VAR   Num_Players : BYTE;
      Playerslist: ARRAY [1..4] of Players;
      Melodie : t_Melodie;
      Fail  : BOOLEAN;

      End_Tune        : CHAR;
      Player     : BYTE;
{}

PROCEDURE Names_enter;

VAR Ch : CHAR;
     i : BYTE;

BEGIN
   Num_Players := 0;
   REPEAT
     CLRSCR;
     GOTOXY(20,2);
     WRITE('T U N E  M E M O R Y  G A M E ');
     GOTOXY(20,5);
     WRITE('How many players ? (1-4): ');
     Ch := READKEY;
     CASE Ch OF
       '1' : Num_Players := 1;
       '2' : Num_Players := 2;
       '3' : Num_Players := 3;
       '4' : Num_Players := 4;
       ELSE WRITE(#7);
     END; { CASE Ch OF }
   UNTIL Num_Players IN[1,2,3,4];
   FOR i:=1 to Num_Players DO
     BEGIN
        GOTOXY(20,2*i+6);
        WITH Playerslist[i] DO
          BEGIN
            WRITE('name of player ',i,': ');
            READLN(name)
          END
     END
END;{Names_enter}
{}

PROCEDURE Startplay;

VAR Start : CHAR;

BEGIN
  REPEAT
    GOTOXY(33,11);
    WRITE(Playerslist[Player].name);
    GOTOXY(20,13);
    WRITE('A R E  Y O U  R E A D Y  ??  (Y)');
    Start := UPCASE(READKEY);
  UNTIL Start = 'Y';
  CLRSCR
END; {Startplay}

{}

PROCEDURE Randommelody_sequence;
VAR i : BYTE;
    Randomnote : BYTE;
  BEGIN { Randommelody_sequence }
    RANDOMIZE;
    FOR i := 1 TO Max_Randomtune DO
      BEGIN
        REPEAT
          Randomnote := RANDOM(5);
        UNTIL Randomnote <> 0;
        Melodie[i] := Randomnote;
      END;
  END;  { Randommelody_sequence }
{}

PROCEDURE Play_sequence_of_notes(i:BYTE);
VAR j,k : INTEGER;
  BEGIN { Play_sequence_of_notes }
    DELAY(1000);
    FOR j := 1 TO i DO
      BEGIN
        SOUND(Melodie[j]*1000);
        FOR k := 1 TO 6000 DO Motor(Melodie[j],cw);
        Motor(Melodie[j], off);
        NOSOUND;
        DELAY(100);
      END;
  END;  { Play_sequence_of_notes }
{}

PROCEDURE Request_sequence(i:BYTE);
VAR j,SwitchNo : BYTE;
  BEGIN { Request_sequence }
    j := 0;
    REPEAT
      INC(j);
      SwitchNo := 0;
      REPEAT
        IF Switch(1) THEN SwitchNo := 1;
        IF Switch(2) THEN SwitchNo := 2;
        IF Switch(3) THEN SwitchNo := 3;
        IF Switch(4) THEN SwitchNo := 4;
      UNTIL SwitchNo <> 0;
      SOUND(SwitchNo * 1000);
      REPEAT
        Motor(SwitchNo,ccw);
        DELAY(10);
      UNTIL NOT Switch(SwitchNo);
      NOSOUND;
      Motor(SwitchNo,off);
      Fail := SwitchNo <> Melodie[j];
    UNTIL Fail OR (i=j);
  END;  { Request_sequence }
{}

PROCEDURE Playtune_and_request_sequence;
VAR i,j : BYTE;
  BEGIN { Playtune_and_request_sequence }
    i := 0;
    REPEAT
      INC(i);
      Play_sequence_of_notes(i);
      Request_sequence(i);
      CLRSCR;
      IF NOT Fail THEN
                      BEGIN
                        GOTOXY(25,10);
                        WRITE('V E R Y  G O O D  !!');
                        GOTOXY(28,13);
                        WRITELN(i:2,' stages');
                      END
                    ELSE
                      BEGIN
                        GOTOXY(25,10);
                        WRITE('G A M E  O V E R  !!!');
                        DELAY(1000);
                        GOTOXY(25,15);
                        WRITE('G A M E  O V E R  !!!');
                        DELAY(2000)
                      END;
    UNTIL Fail OR (i = Max_Randomtune);
    Playerslist[Player].Stage:=i
  END;  { Playtune_and_request_sequence }
{}

PROCEDURE Determine_Winner;

VAR Hilfsvar : Players;
         i,j : BYTE;
BEGIN
  FOR i:=1 to Num_Players - 1  DO
    BEGIN
      FOR j:=i+1 to Num_Players DO
        BEGIN
          IF Playerslist[i].Stage < Playerslist[j].Stage THEN
            BEGIN
                Hilfsvar := Playerslist[i];
                Playerslist[i] := Playerslist[j];
                Playerslist[j] := Hilfsvar
            END
        END
    END
END;{Determine_Winner}

{}

PROCEDURE Display;
VAR i : BYTE;
BEGIN
  GOTOXY(15,3);
  IF Num_Players > 1 THEN
    BEGIN
      IF Playerslist[1].Stage <> Playerslist[2].Stage THEN
        BEGIN
          WRITELN('W I N N E R : ',Playerslist[1].name,'  ',
                   Playerslist[1].Stage,' stage(s)')
        END;
      IF (Playerslist[1].Stage = Playerslist[2].Stage)
         AND (Playerslist[2].Stage = Playerslist[3].Stage)
         AND (Playerslist[3].Stage = Playerslist[4].Stage) THEN
         WRITELN('IT`S A 3-WAY TIE  !!!');
      IF (Playerslist[1].Stage = Playerslist[2].Stage)
         AND(Playerslist[2].Stage = Playerslist[3].Stage)
         AND (Playerslist[3].Stage <> Playerslist[4].Stage) THEN
        WRITELN('IT`S A 2-WAY TIE  !!');
      IF (Playerslist[1].Stage = Playerslist[2].Stage)
         AND (Playerslist[2].Stage <> Playerslist[3].Stage) THEN
        WRITELN('IT`S A 1-WAY TIE  !')
    END;

  FOR i:= 1 to Num_Players DO
    BEGIN
      GOTOXY(15,2*i+6);
      WRITE(i,'.: ',Playerslist[i].name);
      GOTOXY(35,2*i+6);
      WRITE(Playerslist[i].Stage,' stages')
    END
END;{Display}


BEGIN { Tune }
  REPEAT
    NOSOUND;
    Names_enter;
    FOR Player := 1 TO Num_Players DO
      BEGIN
        CLRSCR;
        Startplay;
        DELAY(1000);
        Randommelody_sequence;
        Playtune_and_request_sequence;
      END;
    CLRSCR;
    NOSOUND;
    IF Num_Players > 1 THEN
      Determine_Winner;
    Display;
    GOTOXY(15,20);
    WRITE('New game ?  Y/N ');
    End_Tune := UPCASE(READKEY);
  UNTIL End_Tune = 'N';
  CLRSCR
END.  { Tune }
